unit FInstall;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, UStandard, UManageBase, QButtons, QExtCtrls;

type
  TInstallForm = class(TForm)
    CancelButton: TBitBtn;
    OKButton: TBitBtn;
    OpenDialog: TOpenDialog;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    NamePanel: TPanel;
    Label2: TLabel;
    HintPanel: TPanel;
    Label3: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    coursepath: String;
    coursename: String;
    LastInstallDir: String;
  public
  end;

var
  InstallForm: TInstallForm;

implementation

{$R *.xfm}

procedure TInstallForm.BitBtn1Click(Sender: TObject);
begin
  OKButton.visible := false;
  HintPanel.visible := false;
  NamePanel.caption := '';
  OpenDialog.InitialDir := LastInstallDir;
  OpenDialog.Filter:='Tuxeditor course descriptor (course.tcl)|course.tcl';
  if OpenDialog.Execute then begin
    Coursepath := ExtractFileDir (OpenDialog.FileName);
    if DirectoryExists (coursepath) then begin
      LastInstallDir := ExtractFileDir (coursepath);
      Coursename := ExtractFileName (Coursepath);
      NamePanel.caption := ' ' + coursename;
      if FileExists (iiShareDir + SEP + Coursename) then begin
        HintPanel.color := clYellow;
        HintPanel.visible := true;
        HintPanel.caption := ' This course is already installed';
      end else begin
        HintPanel.Color := $00F1F1F1;
        HintPanel.visible := true;
        HintPanel.caption := ' The course seems to be ok and can be installed';
        OKButton.visible := true;
      end;
    end;

  end;
end;

procedure TInstallForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TInstallForm.OKButtonClick(Sender: TObject);
begin
  CpDir (coursepath, iiShareDir);
  ModalResult := mrOK;
end;

procedure TInstallForm.FormShow(Sender: TObject);
begin
  NamePanel.caption := '';
  OKButton.visible := false;
  HintPanel.visible := false;
end;

procedure TInstallForm.FormCreate(Sender: TObject);
begin
  LastInstallDir := HomeDir;
end;

end.


