unit FLang;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, UStandard, UManageBase, QButtons, QExtCtrls;

const
  LangIdx: String = '[english]0[german]1[french]2[italian]3[spanish]4';
  LangName: array[0..4] of String = ('english','german','french','italian','spanish');  
type
  TLangForm = class(TForm)
    LangRadio: TRadioGroup;
    CancelButton: TBitBtn;
    OKButton: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormShow(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure LangRadioClick(Sender: TObject);
  private
    oldidx: integer;
  public
  end;

var
  LangForm: TLangForm;

implementation

{$R *.xfm}

procedure TLangForm.FormShow(Sender: TObject);
begin
  LangRadio.ItemIndex := ParsInt (LangIdx, iiLanguage, -1);
  oldidx := LangRadio.ItemIndex;
  CancelButton.SetFocus;
end;

procedure TLangForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TLangForm.OKButtonClick(Sender: TObject);
begin
  if oldidx <> LangRadio.ItemIndex then begin
    iiLanguage := LangName[LangRadio.ItemIndex];
    ModalResult := mrOK;
  end else begin
    ModalResult := mrCancel;
  end;
end;

procedure TLangForm.LangRadioClick(Sender: TObject);
begin
  CancelButton.SetFocus;
end;

end.
