unit FOrder;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, UStandard, UManageBase, QButtons;

type
  TOrderForm = class(TForm)
    CancelButton: TBitBtn;
    OKButton: TBitBtn;
    list: TListBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormShow(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure SpeedButton2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    order: array[0..4] of integer;
    procedure ShowList;
  public
  end;

var
  OrderForm: TOrderForm;

implementation

{$R *.xfm}

procedure TOrderForm.ShowList;
var i: integer;
    ss: String;
begin
  list.Clear;
  for i := 0 to 4 do begin
    ss := EventList[order[i]][0];
    list.items.add (ParsStr (ss, 'trivname'));
  end;
end;

procedure TOrderForm.FormShow(Sender: TObject);
var i: integer;
begin
  for i:= 0 to 4 do order[i] := iiOrder[i];
  ShowList;
end;

procedure TOrderForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TOrderForm.OKButtonClick(Sender: TObject);
var i: integer;
begin
  for i := 0 to 4 do iiOrder[i] := order[i];
  ModalResult := mrOK;
end;

procedure TOrderForm.SpeedButton2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var zwi, idx: integer;
begin
  idx := list.ItemIndex;
  if (idx < list.items.count -1) and (idx >=0)  then begin
    zwi := order[idx + 1];
    order[idx+1] := order[idx];
    order[idx] := zwi;
  end;
  ShowList;
  if idx < list.items.count-1 then list.ItemIndex := idx + 1
  else list.ItemIndex := idx;
end;

procedure TOrderForm.SpeedButton1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var zwi, idx: integer;
begin
  idx := list.ItemIndex;
  if idx > 0 then begin
    zwi := order[idx-1];
    order[idx-1] := order[idx];
    order[idx] := zwi;
  end;
  ShowList;
  if idx > 0 then list.ItemIndex := idx - 1 else list.ItemIndex := idx;
end;

end.
