unit UTCL;

interface
uses
  QGraphics, Types, SysUtils, Libc, Classes, Math, QDialogs, QExtCtrls,
  UStandard, UManageBase;

var
  FEvents: TStringList;
  FCourses: TStringList;
  FLang: TStringList;
  Colist: String;

procedure GenerateCourseIdxTcl;
procedure GenerateLightTCL;

function struct0 (list: TStrings; idx: integer): String;  // struct im aktuellen Eintrag
function struct1 (list: TStrings; idx: integer): String;  // struct im nchsten Eintrag
function struct2 (list: TStrings; idx: integer): String;  // struct im bernchsten Eintrag
function structprev (list: TStrings; idx: integer): String;  // struct im nchsten Eintrag


implementation

function struct0;
begin
  if (idx < 0) or (idx >= list.count) then begin
    Result := '';
  end else begin
    Result := ParsStr (list[idx], 'struct');
  end;
end;

function struct1;
begin
  if ((idx+1) < 0) or ((idx+1) >= list.count) then begin
    Result := '';
  end else begin
    Result := ParsStr (list[idx+1], 'struct');
  end;
end;

function structprev;
begin
  if ((idx-1) < 0) or ((idx-1) >= list.count) then begin
    Result := '';
  end else begin
    Result := ParsStr (list[idx-1], 'struct');
  end;
end;

function struct2;
begin
  if ((idx+2) < 0) or ((idx+2) >= list.count) then begin
    Result := '';
  end else begin
    Result := ParsStr (list[idx+2], 'struct');
  end;
end;

procedure GenerateLightTCL; {-------------------------------------}
const vv: array[1..6]of string
      = ('front','right','left','back','top','bottom');
var fi: TStringList;
    env, i: integer;
    ss, sss, dir, path, src, cube, light: String;
    r, g, b: double;
    po1, po2, po3: double;

begin
    if EnvList.count > 0 then for env := 0 to EnvList.Count-1 do begin
      ss := EnvList[env];
      if ParsStr (ss, 'changed') = '1' then begin
        SetParsStr (ss, 'changed', '0');
        EnvList[env] := ss;
        dir := ParsStr (ss, 'dir');
        src := ParsStr (ss, 'src');
        cube := ParsStr (ss, 'cube');
        light := ParsStr (ss, 'light');
        path := iiCourseDir + SEP + dir + SEP + light + '_light.tcl';

        fi := TStringList.Create;
        fi.Add('# generated by Tuxeditor');
        fi.Add('');
        if light = 'foggy' then fi.Add ('objcreate {s_course} {:course} \')
          else fi.Add ('objset :course \');
        fi.Add (chr(9) + '{-light0_on} {1} \');

        r := ParsFloat (ss, 'amb_r', 0) / 255;
        g := ParsFloat (ss, 'amb_g', 0) / 255;
        b := ParsFloat (ss, 'amb_b', 0) / 255;
        fi.Add (chr(9) + '{-light0_ambient} {' + Float_Str (r, 4)
         + ' ' + Float_Str (g, 4) + ' ' + Float_Str (b, 4) + ' 1.0} \');

        r := ParsFloat (ss, 'diff_r', 0) / 255;
        g := ParsFloat (ss, 'diff_g', 0) / 255;
        b := ParsFloat (ss, 'diff_b', 0) / 255;
        fi.Add (chr(9) + '{-light0_diffuse} {' + Float_Str (r, 4)
         + ' ' + Float_Str (g, 4) + ' ' + Float_Str (b, 4) + ' 1.0} \');

        r := ParsFloat (ss, 'spec_r', 0) / 255;
        g := ParsFloat (ss, 'spec_g', 0) / 255;
        b := ParsFloat (ss, 'spec_b', 0) / 255;
        fi.Add (chr(9) + '{-light0_specular} {' + Float_Str (r, 4)
         + ' ' + Float_Str (g, 4) + ' ' + Float_Str (b, 4) + ' 1.0} \');

        po1 := ParsFloat (ss, 'pos_1', 0);
        po2 := ParsFloat (ss, 'pos_2', 0);
        po3 := ParsFloat (ss, 'pos_3', 0);
        fi.Add (chr(9) + '{-light0_position} {' + Float_Str (po1, 4)
         + ' ' + Float_Str (po2, 4) + ' ' + Float_Str (po3, 4) + ' 0.0}');
        fi.Add ('');

        r := ParsFloat (ss, 'fog_r', 0) / 255;
        g := ParsFloat (ss, 'fog_g', 0) / 255;
        b := ParsFloat (ss, 'fog_b', 0) / 255;

        if light = 'foggy' then begin
          fi.Add ('set fog_dist 50');
          fi.Add ('set far_clip [tux_get_param forward_clip_distance]');
          fi.Add ('if { $fog_dist > $far_clip } {');
          fi.add (chr(9) + 'set fog_dist $far_clip');
          fi.Add ('}');
          fi.Add ('');
          sss := 'tux_fog -on -mode linear -start -10 -end $fog_dist -colour { ';
          sss := sss + Float_Str (r, 4) + ' ' + Float_Str (g, 4)
                 + ' ' + Float_Str (b, 4) + ' 1.0 }';
          fi.Add (sss);
        end else begin; // sunny and sunset
          sss := 'tux_fog -on -mode linear -density 0.005 -colour { ';
          sss := sss + Float_Str (r, 4) + ' ' + Float_Str (g, 4)
                 + ' ' + Float_Str (b, 4) + ' 1.0 } ';
          sss := sss + '-start 0 \';
          fi.Add (sss);
          fi.Add (chr(9) + '-end [tux_get_param forward_clip_distance]');
        end;
        fi.Add ('');

        r := ParsFloat (ss, 'part_r', 0) / 255;
        g := ParsFloat (ss, 'part_g', 0) / 255;
        b := ParsFloat (ss, 'part_b', 0) / 255;
        fi.Add ('tux_particle_colour { ' + Float_Str (r, 4)
        + ' ' + Float_Str (g, 4) + ' ' + Float_Str (b, 4) + ' 1.0 }');
        fi.Add ('');

        fi.Add ('tux_load_texture envmap ../' + src + '/' + cube + 'right.png 0');
        fi.Add ('');

        for i := 1 to 6 do begin
          sss := 'tux_load_texture ' + src + '-' + vv[i];
          sss := sss + ' ../' + src + '/' + cube + vv[i] + '.png 0';
          fi.Add (sss);
        end;
        fi.Add('');

        for i:=1 to 6 do begin
          fi.Add ('tux_bind_texture sky_' + vv[i] + ' ' + src + '-' + vv[i]);
        end;
        fi.Add('');

        fi.Add ('objcreate {s_texture_cube} {:textures:cubemap} \');
        fi.Add (chr(9) + '{-filename} {../' + src + '/' + cube + '}');

        fi.SaveToFile (path);
        fi.Free;
      end;
    end;

(*




    case light of
      tlSunny: fi.SaveToFile (iiCourseDir + SEP + dir + SEP + 'sunny_light.tcl');
      tlSunset: fi.SaveToFile (iiCourseDir + SEP + dir + SEP + 'sunset_light.tcl');
      tlFoggy: fi.SaveToFile (iiCourseDir + SEP + dir + SEP + 'foggy_light.tcl');
    end;

  fi.free;*)
end;

{--------------------------------------------------------------}
{                   course_idx.tcl                             }
{--------------------------------------------------------------}

procedure GenerateCourseIdxTcl; {==============================}
var fi: TStringList;
    ev, i, cnt, order: integer;
    name, trivname, desc, ss: String;

procedure InsertTrls; {........................................}
var i: integer;
begin
  fi.add ('array set tr_ls {');
  for i := 0 to FLang.count-1 do begin
    fi.add (FLang[i]);
  end;
  fi.add ('}');
  fi.add ('');
end;

procedure InsertCourses; {.....................................}
var s, cc: String;
    i: integer;
begin
  for i := 0 to FCourses.count-1 do begin
    cc := FCourses[i];
    fi.add('lappend open_course_list [ list  \');
    s := chr(9) + '-course "' + ParsStr (cc, 'cupdir') + '/';
    s := s + ParsStr (cc, 'name');
    s := s + '" -name [ gs ';
    s := s + ParsStr (cc, 'name') + ' ] \';
    fi.add (s);
    s := chr(9) + '-description [ gs ';
    s := s + ParsStr (cc, 'name') + '_desc ] \';
    fi.add (s);
    fi.add (chr(9) + '-par_time 150.0 ]');
  end;
end;

procedure InsertEvent (idx: integer); {........................}
var struct, cc, s, name: String;
    t1, t2, t3, h1, h2, h3: integer;
begin
  cc := FEvents[idx];
  name := ParsStr (cc, 'name');
  struct := struct0 (FEvents, idx);
  t1 := ParsInt (cc, 'time1', 200);
  t2 := ParsInt (cc, 'time2', 200);
  t3 := ParsInt (cc, 'time3', 200);
  h1 := ParsInt (cc, 'her1', 0);
  h2 := ParsInt (cc, 'her2', 0);
  h3 := ParsInt (cc, 'her3', 0);
  if struct = 'event' then begin
    if (struct1 (FEvents, idx) = 'cup')
      and (struct2 (FEvents, idx) = 'course') then begin
      fi.add ('    [ list \');
      s := '    -name [ gs ';
      s := s + name;
      s := s + ' ] -icon herring_run_icon -cups [ list \';
      fi.add (s);
    end;
  end else if struct = 'cup' then begin
    if struct1 (FEvents, idx) = 'course' then begin
      fi.add ('      [ list \');
      s := '      -name [ gs ';
      s := s + name + ' ] -icon cup_icon -races [ list \';
      fi.add (s);
    end;
  end else if struct = 'course' then begin
    fi.add ('        [ list \');
    s := '          -course ';
    s := s + ParsStr (cc, 'cupdir') + '/' + name + ' \';
    fi.add (s);
    s := '          -name [ gs ';
    s := s + name + ' ] \';
    fi.add (s);
    s := '          -description [ gs ';
    s := s + name + '_desc ] \';
    fi.add (s);
    s := '          -herring { ' + IntToStr (h1);
    s := s + ' ' + IntToStr (h2) + ' ' + IntToStr (h3) + ' } \';
    fi.add (s);
    s := '          -time { ' + IntToStr (t1);
    s := s + ' ' + IntToStr (t2) + ' ' + IntToStr (t3) + ' } \';
    fi.add (s);
    s := '          -par_time ' + IntToStr (t1) + ' \';
    fi.add (s);
    s := '          -score { 0 0 0 } \';
    fi.add (s);
    if ParsInt (cc, 'opp', 0) > 0 then begin
      s := '          -opponents { 1 1 1 } \';
      fi.add (s);
    end;
    s := '          -mirrored ' + ParsStr (cc, 'mirr');
    s := s + ' -conditions ' + ParsStr (cc, 'cond') + ' \';
    fi.add (s);
    s := '          -windy ' + ParsStr (cc, 'wind');
    s := s + ' -snowing ' + ParsStr (cc, 'snow');
    fi.add (s);
    if struct1 (FEvents, idx) = 'course' then begin
      fi.add ('        ] \');
    end else if struct1 (FEvents, idx) = 'cup' then begin
      fi.add ('        ]');
      fi.add ('        ]');
      fi.add ('      ] \');
    end else if struct1 (FEvents, idx) = 'event' then begin
      fi.add ('        ]');
      fi.add ('        ]');
      fi.add ('      ]');
      fi.add ('      ]');
      fi.add ('    ] \');
    end else begin // end of list
      fi.add ('        ]');
      fi.add ('        ]');
      fi.add ('      ]');
      fi.add ('    ]');
      fi.add ('  ]');
      fi.add (']');

    end
  end;
end;

begin {........................................................}
  if iiCourseDirOK = false then exit;

  {--- Vorbereitungen ---}
  // Events zusammenfhren und die verwendeten Kurse in Courses
  // entsprechend iiOrder auflisten
  // Doppelungen vermeiden, deshalb colist)
  FEvents := TStringList.Create;
  FCourses := TStringList.Create;
  FLang := TStringList.Create;
  colist := '';
  cnt := 0;
  for order := 0 to 4 do begin
    ev := iiOrder[order];
    for i := 0 to EventList[ev].count-1 do begin
      ss := EventList[ev][i];
      if ParsStr (ss, 'struct') = 'course' then begin
        name := ParsStr (ss, 'name');
        if pos ('*' + name + '*', colist) = 0 then begin
          inc(cnt);
          colist := colist + '[' + IntToStr(cnt) + ']*' + name + '*';
          FCourses.Add (ss);
        end;
      end;
      FEvents.Add (ss);
    end;
  end;
  colist := colist + '[cnt]' + IntToStr(cnt);

  // make proper FEvents - delete cups which are not followed by courses
  for i := FEvents.Count-1 downto 0 do begin
    ss := FEvents[i];
    if ParsStr (ss, 'struct') = 'cup' then begin
      if struct1 (FEvents, i) <> 'course' then FEvents.Delete(i);
    end;
  end;
  // delete events which are not followed by cups
  for i := FEvents.Count-1 downto 0 do begin
    ss := FEvents[i];
    if ParsStr (ss, 'struct') = 'event' then begin
      if struct1 (FEvents, i) <> 'cup' then FEvents.Delete(i);
    end;
  end;

  // prepare translations in FLang
  FLang.Clear;
  // first the events
  for i := 0 to FEvents.count-1 do begin
    ss := FEvents[i];
    if ParsStr (ss, 'struct') = 'event' then begin
      name := ParsStr (ss, 'name');
      trivname := ParsStr (ss, 'trivname');
      FLang.Add (chr(9) + iiLanguage + ',' + name + ' "' + trivname + '"');
    end;
  end;

  // then the cups
  for i := 0 to FEvents.count-1 do begin
    ss := FEvents[i];
    if ParsStr (ss, 'struct') = 'cup' then begin
      name := ParsStr (ss, 'name');
      trivname := ParsStr (ss, 'trivname');
      FLang.Add (chr(9) + iiLanguage + ',' + name + ' "' + trivname + '"');
    end;
  end;
  
  // at least the courses, related to FCourses
  for i := 0 to FCourses.count-1 do begin
    ss := FCourses[i];
    name := ParsStr (ss, 'name');
    trivname := ParsStr (CourseNames, name);
    if trivname = '' then trivname := ParsStr (ss, 'trivname');
    desc := ParsStr (CourseDesc, name);
    if desc = '' then desc := ParsStr (ss, 'desc');
    FLang.Add (chr(9) + iiLanguage + ',' + name + ' "' + trivname + '"');
    FLang.Add (chr(9) + iiLanguage + ',' + name + '_desc "' + desc + '"');
  end;


  fi := TStringList.Create;
  fi.Add ('# generated by Tuxmanager');
  fi.Add ('');
  fi.Add ('set cwd [pwd]');
  fi.Add ('tux_goto_data_dir');
  fi.Add ('');
  fi.Add('tux_load_texture noicon textures/noicon.png 0');
  fi.Add ('');
  fi.Add ('cd courses');
  fi.Add ('');
  fi.Add ('tux_load_texture no_preview common/nopreview.png 0');
  fi.Add ('tux_bind_texture no_preview no_preview');
  fi.Add ('');
  fi.add('foreach cup [glob -nocomplain *] {');
  fi.add('    if { $cup == "common" || $cup == "contrib" } {');
  fi.add('        continue;');
  fi.add('    }');
  fi.add('    if [file isdirectory $cup] {');
  fi.add('	foreach course [glob -nocomplain "$cup/*"] {');
  fi.add('	    if [file exists "$course/preview.png"] {');
  fi.add('		set course [string tolower $course] ;');
  fi.add('		tux_load_texture $course "$course/preview.png" 0');
  fi.add('		tux_bind_texture $course $course');
  fi.add('	    }');
  fi.add('	}');
  fi.add('    }');
  fi.add('}');
  fi.add('');
  fi.add('set contrib_course_list {}');
  fi.add('set open_course_list {}');
  fi.add('');

  InsertTrls;
  InsertCourses;

  fi.add ('');
  fi.add ('tux_open_courses [concat $open_course_list $contrib_course_list ]');
  fi.add ('');
  fi.add ('tux_load_texture herring_run_icon common/herringrunicon.png 0');
  fi.add ('tux_load_texture cup_icon common/cupicon.png 0');
  fi.add ('');

  fi.add ('tux_events [ list \');
  for i := 0 to FEvents.count-1 do InsertEvent (i);

  fi.add('');
  fi.add('cd $cwd');

  fi.SaveToFile (iiCourseDir + SEP + 'course_idx.tcl');
  fi.Free;
  FEvents.Free;
  FCourses.Free;
  FLang.Free;

end;


end.
